import { IPrefixList } from 'aws-cdk-lib/aws-ec2';
import { Construct } from 'constructs';
export interface AwsManagedPrefixListProps {
    /**
     * Name of the aws managed prefix list.
     * See: https://docs.aws.amazon.com/vpc/latest/userguide/working-with-aws-managed-prefix-lists.html#available-aws-managed-prefix-lists
     * eg. com.amazonaws.global.cloudfront.origin-facing
     *
     * see all via aws ec2 describe-managed-prefix-lists  --region <REGION> | jq -r '.PrefixLists[] | select (.PrefixListName == "com.amazonaws.global.cloudfront.origin-facing") | .PrefixListId'
     */
    readonly name: string;
}
export declare class AwsManagedPrefixList extends Construct {
    readonly prefixList: IPrefixList;
    constructor(scope: Construct, id: string, { name }: AwsManagedPrefixListProps);
}
