import { IResource } from 'aws-cdk-lib/core';
import { Construct } from 'constructs';
export interface Secret {
    username: string;
    password: string;
}
export interface SecretRetrieverOptionsBase {
    readonly secretArn: string;
}
export interface SecretRetrieverOptions extends SecretRetrieverOptionsBase {
}
export declare abstract class SecretRetriever {
    static new(options: SecretRetrieverOptions): SecretRetriever;
    secretArn: string;
    /**
     * The ARN of the secretRetriever in SSM.
     */
    secretRetrieverArn: string;
    /**
     * The plaintext secret
     */
    secretPlaintext: Secret;
    secretPasswordPlaintext: string;
    customResource: IResource;
    /**
     * @internal
     */
    protected constructor();
    /**
     * @internal
     */
    abstract _bind(scope: Construct): any;
}
